#ifndef LINES_H
#define LINES_H

/*
 * lines.h
 *
 * $Id :$
 * $Log:$
 *
 */

#ifndef  DEFS_H
#include "defs.h"
#endif

#ifndef  ERRORS_H
#include "errors.h"
#endif

#ifndef  EXEC_NODES_H
#include <exec/nodes.h>
#endif


typedef UWORD           LINE_LEN_TYPE;
#define MAX_LINE_LEN    65534


struct Line
{
	struct MinNode  Node;       /* list node header */
	STRPTR          Contents;   /* pointer to string (not necessarily null terminated!) */
	LINE_LEN_TYPE   Length;     /* number of chars in string */
};

typedef struct Line  LINE_TYPE;
typedef struct Line *LINE_PTR;


LINE_PTR        Line_New( STRPTR string, LINE_LEN_TYPE len, ULONG  *err_code );
VOID            Line_Dispose( LINE_PTR line );
STRPTR          Line_GetContents( LINE_PTR line );
LINE_LEN_TYPE   Line_GetLength( LINE_PTR line );

#ifdef DEBUG

#ifndef  DOS_DOS_H
#include <dos/dos.h>
#endif

VOID            Line_FPuts( BPTR file, LINE_PTR line );

#endif /* DEBUG */

#endif /* LINES_H */
